diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/media.php ./wordpress-3.3/wp-admin/includes/media.php
*** ./wordpress-3.2.1/wp-admin/includes/media.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/media.php	2011-11-30 22:51:35.000000000 -0600
***************
*** 1582,1595 ****
  		<a href="#" onclick="try{top.tb_remove();}catch(e){}; return false;"><?php _e('Cancel'); ?></a>
  	</p>
  	<div class="clear"></div>
! 	<p class="media-upload-size"><?php printf( __( 'Maximum upload file size: %d%s' ), $upload_size_unit, $sizes[$u] ); ?></p>
! 	<?php if ( is_lighttpd_before_150() ): ?>
! 	<p><?php _e('If you want to use all capabilities of the uploader, like uploading multiple files at once, please update to lighttpd 1.5.'); ?></p>
! 	<?php endif;?>
! <?php do_action('post-html-upload-ui', $flash); ?>
  </div>
! <?php do_action('post-upload-ui'); ?>
  <?php
  }
  
  /**
--- 1384,1399 ----
  		<a href="#" onclick="try{top.tb_remove();}catch(e){}; return false;"><?php _e('Cancel'); ?></a>
  	</p>
  	<div class="clear"></div>
! <?php do_action('post-html-upload-ui'); ?>
  </div>
! 
! <span class="max-upload-size"><?php printf( __( 'Maximum upload file size: %d%s.' ), esc_html($upload_size_unit), esc_html($sizes[$u]) ); ?></span>
  <?php
+ if ( ($is_IE || $is_opera) && $max_upload_size > 100 * 1024 * 1024 ) { ?>
+ 	<span class="big-file-warning"><?php _e('Your browser has some limitations uploading large files with the multi-file uploader. Please use the browser uploader for files over 100MB.'); ?></span>
+ <?php }
+ 
+ 	do_action('post-upload-ui');
  }
  
  /**
***************
*** 1602,1616 ****
   * @param unknown_type $id
   */
  function media_upload_type_form($type = 'file', $errors = null, $id = null) {
  	media_upload_header();
  
  	$post_id = isset( $_REQUEST['post_id'] )? intval( $_REQUEST['post_id'] ) : 0;
  
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=type&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
  ?>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="media-upload-form type-form validate" id="<?php echo $type; ?>-form">
  <?php submit_button( '', 'hidden', 'save', false ); ?>
  <input type="hidden" name="post_id" id="post_id" value="<?php echo (int) $post_id; ?>" />
  <?php wp_nonce_field('media-form'); ?>
--- 1406,1429 ----
   * @param unknown_type $id
   */
  function media_upload_type_form($type = 'file', $errors = null, $id = null) {
+ 	global $is_iphone;
+ 
+ 	if ( $is_iphone )
+ 		return;
+ 
  	media_upload_header();
  
  	$post_id = isset( $_REQUEST['post_id'] )? intval( $_REQUEST['post_id'] ) : 0;
  
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=type&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
+ 	$form_class = 'media-upload-form type-form validate';
+ 
+ 	if ( get_user_setting('uploader') )
+ 		$form_class .= ' html-uploader';
  ?>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="<?php echo $form_class; ?>" id="<?php echo $type; ?>-form">
  <?php submit_button( '', 'hidden', 'save', false ); ?>
  <input type="hidden" name="post_id" id="post_id" value="<?php echo (int) $post_id; ?>" />
  <?php wp_nonce_field('media-form'); ?>
***************
*** 1630,1648 ****
  });
  //]]>
  </script>
! <div id="media-items">
! <?php
  if ( $id ) {
  	if ( !is_wp_error($id) ) {
  		add_filter('attachment_fields_to_edit', 'media_post_single_attachment_fields_to_edit', 10, 2);
  		echo get_media_items( $id, $errors );
  	} else {
! 		echo '<div id="media-upload-error">'.esc_html($id->get_error_message()).'</div>';
  		exit;
  	}
  }
! ?>
! </div>
  <p class="savebutton ml-submit">
  <?php submit_button( __( 'Save all changes' ), 'button', 'save', false ); ?>
  </p>
--- 1443,1461 ----
  });
  //]]>
  </script>
! <div id="media-items"><?php
! 
  if ( $id ) {
  	if ( !is_wp_error($id) ) {
  		add_filter('attachment_fields_to_edit', 'media_post_single_attachment_fields_to_edit', 10, 2);
  		echo get_media_items( $id, $errors );
  	} else {
! 		echo '<div id="media-upload-error">'.esc_html($id->get_error_message()).'</div></div>';
  		exit;
  	}
  }
! ?></div>
! 
  <p class="savebutton ml-submit">
  <?php submit_button( __( 'Save all changes' ), 'button', 'save', false ); ?>
  </p>
***************
*** 1659,1682 ****
   * @param unknown_type $errors
   * @param unknown_type $id
   */
! function media_upload_type_url_form($type = 'file', $errors = null, $id = null) {
  	media_upload_header();
  
  	$post_id = intval($_REQUEST['post_id']);
  
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=type&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
  
! 	$callback = "type_url_form_$type";
  ?>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="media-upload-form type-form validate" id="<?php echo $type; ?>-form">
  <input type="hidden" name="post_id" id="post_id" value="<?php echo (int) $post_id; ?>" />
  <?php wp_nonce_field('media-form'); ?>
  
! <?php if ( is_callable($callback) ) { ?>
! 
! <h3 class="media-title"><?php _e('Add media file from URL'); ?></h3>
  
  <script type="text/javascript">
  //<![CDATA[
--- 1472,1498 ----
   * @param unknown_type $errors
   * @param unknown_type $id
   */
! function media_upload_type_url_form($type = null, $errors = null, $id = null) {
! 	if ( null === $type )
! 		$type = 'image';
! 
  	media_upload_header();
  
  	$post_id = intval($_REQUEST['post_id']);
  
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=type&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
+ 	$form_class = 'media-upload-form type-form validate';
  
! 	if ( get_user_setting('uploader') )
! 		$form_class .= ' html-uploader';
  ?>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="<?php echo $form_class; ?>" id="<?php echo $type; ?>-form">
  <input type="hidden" name="post_id" id="post_id" value="<?php echo (int) $post_id; ?>" />
  <?php wp_nonce_field('media-form'); ?>
  
! <h3 class="media-title"><?php _e('Insert media from another website'); ?></h3>
  
  <script type="text/javascript">
  //<![CDATA[
***************
*** 1709,1716 ****
  
  		html = '<img alt="'+alt+'" src="'+f.src.value+'"'+title+cls+' width="'+t.width+'" height="'+t.height+'" />';
  
! 		if ( f.url.value )
! 			html = '<a href="'+f.url.value+'">'+html+'</a>';
  
  		if ( caption )
  			html = '[caption id="" align="'+t.align+'" width="'+t.width+'" caption="'+caption+'"]'+html+'[/caption]';
--- 1525,1534 ----
  
  		html = '<img alt="'+alt+'" src="'+f.src.value+'"'+title+cls+' width="'+t.width+'" height="'+t.height+'" />';
  
! 		if ( f.url.value ) {
! 			url = f.url.value.replace(/'/g, '&#039;').replace(/"/g, '&quot;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
! 			html = '<a href="'+url+'">'+html+'</a>';
! 		}
  
  		if ( caption )
  			html = '[caption id="" align="'+t.align+'" width="'+t.width+'" caption="'+caption+'"]'+html+'[/caption]';
***************
*** 1740,1745 ****
--- 1558,1566 ----
  	},
  
  	getImageData : function() {
+ 		if ( jQuery('table.describe').hasClass('not-image') )
+ 			return;
+ 
  		var t = addExtImage, src = document.forms[0].src.value;
  
  		if ( ! src ) {
***************
*** 1753,1771 ****
  		t.preloadImg.src = src;
  	}
  }
  //]]>
  </script>
  
  <div id="media-items">
  <div class="media-item media-blank">
! <?php echo apply_filters($callback, call_user_func($callback)); ?>
  </div>
  </div>
  </form>
  <?php
- 	} else {
- 		wp_die( __('Unknown action.') );
- 	}
  }
  
  /**
--- 1575,1597 ----
  		t.preloadImg.src = src;
  	}
  }
+ 
+ jQuery(document).ready( function($) {
+ 	$('.media-types input').click( function() {
+ 		$('table.describe').toggleClass('not-image', $('#not-image').prop('checked') );
+ 	});
+ });
+ 
  //]]>
  </script>
  
  <div id="media-items">
  <div class="media-item media-blank">
! <?php echo apply_filters( 'type_url_form_media', wp_media_insert_url_form( $type ) ); ?>
  </div>
  </div>
  </form>
  <?php
  }
  
  /**
***************
*** 1784,1789 ****
--- 1610,1619 ----
  	$post_id = intval($_REQUEST['post_id']);
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=gallery&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
+ 	$form_class = 'media-upload-form validate';
+ 
+ 	if ( get_user_setting('uploader') )
+ 		$form_class .= ' html-uploader';
  ?>
  
  <script type="text/javascript">
***************
*** 1808,1814 ****
  <a href="#" id="desc"><?php _e('Descending'); ?></a> |
  <a href="#" id="clear"><?php _ex('Clear', 'verb'); ?></a>
  </div>
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="media-upload-form validate" id="gallery-form">
  <?php wp_nonce_field('media-form'); ?>
  <?php //media_upload_form( $errors ); ?>
  <table class="widefat" cellspacing="0">
--- 1638,1644 ----
  <a href="#" id="desc"><?php _e('Descending'); ?></a> |
  <a href="#" id="clear"><?php _ex('Clear', 'verb'); ?></a>
  </div>
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="<?php echo $form_class; ?>" id="gallery-form">
  <?php wp_nonce_field('media-form'); ?>
  <?php //media_upload_form( $errors ); ?>
  <table class="widefat" cellspacing="0">
***************
*** 1858,1864 ****
  		<select id="orderby" name="orderby">
  			<option value="menu_order" selected="selected"><?php _e('Menu order'); ?></option>
  			<option value="title"><?php _e('Title'); ?></option>
! 			<option value="ID"><?php _e('Date/Time'); ?></option>
  			<option value="rand"><?php _e('Random'); ?></option>
  		</select>
  	</td>
--- 1688,1694 ----
  		<select id="orderby" name="orderby">
  			<option value="menu_order" selected="selected"><?php _e('Menu order'); ?></option>
  			<option value="title"><?php _e('Title'); ?></option>
! 			<option value="post_date"><?php _e('Date/Time'); ?></option>
  			<option value="rand"><?php _e('Random'); ?></option>
  		</select>
  	</td>
***************
*** 1926,1931 ****
--- 1756,1765 ----
  
  	$form_action_url = admin_url("media-upload.php?type=$type&tab=library&post_id=$post_id");
  	$form_action_url = apply_filters('media_upload_form_url', $form_action_url, $type);
+ 	$form_class = 'media-upload-form validate';
+ 
+ 	if ( get_user_setting('uploader') )
+ 		$form_class .= ' html-uploader';
  
  	$_GET['paged'] = isset( $_GET['paged'] ) ? intval($_GET['paged']) : 0;
  	if ( $_GET['paged'] < 1 )
***************
*** 2043,2049 ****
  </div>
  </form>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="media-upload-form validate" id="library-form">
  
  <?php wp_nonce_field('media-form'); ?>
  <?php //media_upload_form( $errors ); ?>
--- 1877,1883 ----
  </div>
  </form>
  
! <form enctype="multipart/form-data" method="post" action="<?php echo esc_attr($form_action_url); ?>" class="<?php echo $form_class; ?>" id="library-form">
  
  <?php wp_nonce_field('media-form'); ?>
  <?php //media_upload_form( $errors ); ?>
***************
*** 2079,2088 ****
   *
   * @return unknown
   */
! function type_url_form_image() {
  	if ( !apply_filters( 'disable_captions', '' ) ) {
  		$caption = '
! 		<tr>
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="caption">' . __('Image Caption') . '</label></span>
  			</th>
--- 1913,1922 ----
   *
   * @return unknown
   */
! function wp_media_insert_url_form( $default_view = 'image' ) {
  	if ( !apply_filters( 'disable_captions', '' ) ) {
  		$caption = '
! 		<tr class="image-only">
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="caption">' . __('Image Caption') . '</label></span>
  			</th>
***************
*** 2097,2108 ****
  	if ( empty($default_align) )
  		$default_align = 'none';
  
  	return '
! 	<h4 class="media-sub-title">' . __('Insert an image from another web site') . '</h4>
! 	<table class="describe"><tbody>
  		<tr>
  			<th valign="top" scope="row" class="label" style="width:130px;">
! 				<span class="alignleft"><label for="src">' . __('Image URL') . '</label></span>
  				<span class="alignright"><abbr id="status_img" title="required" class="required">*</abbr></span>
  			</th>
  			<td class="field"><input id="src" name="src" value="" type="text" aria-required="true" onblur="addExtImage.getImageData()" /></td>
--- 1931,1949 ----
  	if ( empty($default_align) )
  		$default_align = 'none';
  
+ 	if ( 'image' == $default_view ) {
+ 		$view = 'image-only';
+ 		$table_class = '';
+ 	} else {
+ 		$view = $table_class = 'not-image';
+ 	}
+ 
  	return '
! 	<p class="media-types"><label><input type="radio" name="media_type" value="image" id="image-only"' . checked( 'image-only', $view, false ) . ' /> ' . __( 'Image' ) . '</label> &nbsp; &nbsp; <label><input type="radio" name="media_type" value="generic" id="not-image"' . checked( 'not-image', $view, false ) . ' /> ' . __( 'Audio, Video, or Other File' ) . '</label></p>
! 	<table class="describe ' . $table_class . '"><tbody>
  		<tr>
  			<th valign="top" scope="row" class="label" style="width:130px;">
! 				<span class="alignleft"><label for="src">' . __('URL') . '</label></span>
  				<span class="alignright"><abbr id="status_img" title="required" class="required">*</abbr></span>
  			</th>
  			<td class="field"><input id="src" name="src" value="" type="text" aria-required="true" onblur="addExtImage.getImageData()" /></td>
***************
*** 2110,2122 ****
  
  		<tr>
  			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="title">' . __('Image Title') . '</label></span>
  				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
  			</th>
  			<td class="field"><input id="title" name="title" value="" type="text" aria-required="true" /></td>
  		</tr>
  
! 		<tr>
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="alt">' . __('Alternate Text') . '</label></span>
  			</th>
--- 1951,1965 ----
  
  		<tr>
  			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="title">' . __('Title') . '</label></span>
  				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
  			</th>
  			<td class="field"><input id="title" name="title" value="" type="text" aria-required="true" /></td>
  		</tr>
  
! 		<tr class="not-image"><td></td><td><p class="help">' . __('Link text, e.g. &#8220;Ransom Demands (PDF)&#8221;') . '</p></td></tr>
! 
! 		<tr class="image-only">
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="alt">' . __('Alternate Text') . '</label></span>
  			</th>
***************
*** 2124,2130 ****
  			<p class="help">' . __('Alt text for the image, e.g. &#8220;The Mona Lisa&#8221;') . '</p></td>
  		</tr>
  		' . $caption . '
! 		<tr class="align">
  			<th valign="top" scope="row" class="label"><p><label for="align">' . __('Alignment') . '</label></p></th>
  			<td class="field">
  				<input name="align" id="align-none" value="none" onclick="addExtImage.align=\'align\'+this.value" type="radio"' . ($default_align == 'none' ? ' checked="checked"' : '').' />
--- 1967,1973 ----
  			<p class="help">' . __('Alt text for the image, e.g. &#8220;The Mona Lisa&#8221;') . '</p></td>
  		</tr>
  		' . $caption . '
! 		<tr class="align image-only">
  			<th valign="top" scope="row" class="label"><p><label for="align">' . __('Alignment') . '</label></p></th>
  			<td class="field">
  				<input name="align" id="align-none" value="none" onclick="addExtImage.align=\'align\'+this.value" type="radio"' . ($default_align == 'none' ? ' checked="checked"' : '').' />
***************
*** 2138,2144 ****
  			</td>
  		</tr>
  
! 		<tr>
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="url">' . __('Link Image To:') . '</label></span>
  			</th>
--- 1981,1987 ----
  			</td>
  		</tr>
  
! 		<tr class="image-only">
  			<th valign="top" scope="row" class="label">
  				<span class="alignleft"><label for="url">' . __('Link Image To:') . '</label></span>
  			</th>
***************
*** 2148,2250 ****
  			<button type="button" class="button" value="" onclick="document.forms[0].url.value=document.forms[0].src.value">' . __('Link to image') . '</button>
  			<p class="help">' . __('Enter a link URL or click above for presets.') . '</p></td>
  		</tr>
! 	' . _insert_into_post_button('image') . '
! 	</tbody></table>
! ';
! 
! }
! 
! /**
!  * {@internal Missing Short Description}}
!  *
!  * @since 2.7.0
!  *
!  * @return unknown
!  */
! function type_url_form_audio() {
! 	return '
! 	<table class="describe"><tbody>
! 		<tr>
! 			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="insertonly[href]">' . __('Audio File URL') . '</label></span>
! 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
! 			</th>
! 			<td class="field"><input id="insertonly[href]" name="insertonly[href]" value="" type="text" aria-required="true"></td>
! 		</tr>
! 		<tr>
! 			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="insertonly[title]">' . __('Title') . '</label></span>
! 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
! 			</th>
! 			<td class="field"><input id="insertonly[title]" name="insertonly[title]" value="" type="text" aria-required="true"></td>
! 		</tr>
! 		<tr><td></td><td class="help">' . __('Link text, e.g. &#8220;Still Alive by Jonathan Coulton&#8221;') . '</td></tr>
! 	' . _insert_into_post_button('audio') . '
! 	</tbody></table>
! ';
! }
! 
! /**
!  * {@internal Missing Short Description}}
!  *
!  * @since 2.7.0
!  *
!  * @return unknown
!  */
! function type_url_form_video() {
! 	return '
! 	<table class="describe"><tbody>
! 		<tr>
! 			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="insertonly[href]">' . __('Video URL') . '</label></span>
! 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
! 			</th>
! 			<td class="field"><input id="insertonly[href]" name="insertonly[href]" value="" type="text" aria-required="true"></td>
  		</tr>
! 		<tr>
! 			<th valign="top" scope="row" class="label">
! 				<span class="alignleft"><label for="insertonly[title]">' . __('Title') . '</label></span>
! 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
! 			</th>
! 			<td class="field"><input id="insertonly[title]" name="insertonly[title]" value="" type="text" aria-required="true"></td>
  		</tr>
- 		<tr><td></td><td class="help">' . __('Link text, e.g. &#8220;Lucy on YouTube&#8221;') . '</td></tr>
- 	' . _insert_into_post_button('video') . '
  	</tbody></table>
  ';
- }
  
- /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.7.0
-  *
-  * @return unknown
-  */
- function type_url_form_file() {
- 	return '
- 	<table class="describe"><tbody>
- 		<tr>
- 			<th valign="top" scope="row" class="label">
- 				<span class="alignleft"><label for="insertonly[href]">' . __('URL') . '</label></span>
- 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
- 			</th>
- 			<td class="field"><input id="insertonly[href]" name="insertonly[href]" value="" type="text" aria-required="true"></td>
- 		</tr>
- 		<tr>
- 			<th valign="top" scope="row" class="label">
- 				<span class="alignleft"><label for="insertonly[title]">' . __('Title') . '</label></span>
- 				<span class="alignright"><abbr title="required" class="required">*</abbr></span>
- 			</th>
- 			<td class="field"><input id="insertonly[title]" name="insertonly[title]" value="" type="text" aria-required="true"></td>
- 		</tr>
- 		<tr><td></td><td class="help">' . __('Link text, e.g. &#8220;Ransom Demands (PDF)&#8221;') . '</td></tr>
- 	' . _insert_into_post_button('file') . '
- 	</tbody></table>
- ';
  }
  
- 
  function _insert_into_post_button($type) {
  	if ( !post_type_supports(get_post_type($_GET['post_id']), 'editor') )
  		return '';
--- 1991,2013 ----
  			<button type="button" class="button" value="" onclick="document.forms[0].url.value=document.forms[0].src.value">' . __('Link to image') . '</button>
  			<p class="help">' . __('Enter a link URL or click above for presets.') . '</p></td>
  		</tr>
! 		<tr class="image-only">
! 			<td></td>
! 			<td>
! 				<input type="button" class="button" id="go_button" style="color:#bbb;" onclick="addExtImage.insert()" value="' . esc_attr__('Insert into Post') . '" />
! 			</td>
  		</tr>
! 		<tr class="not-image">
! 			<td></td>
! 			<td>
! 				' . get_submit_button( __( 'Insert into Post' ), 'button', 'insertonlybutton', false ) . '
! 			</td>
  		</tr>
  	</tbody></table>
  ';
  
  }
  
  function _insert_into_post_button($type) {
  	if ( !post_type_supports(get_post_type($_GET['post_id']), 'editor') )
  		return '';
***************
*** 2272,2350 ****
  /**
   * {@internal Missing Short Description}}
   *
-  * Support a GET parameter for disabling the flash uploader.
-  *
-  * @since 2.6.0
-  *
-  * @param unknown_type $flash
-  * @return unknown
-  */
- function media_upload_use_flash($flash) {
- 	if ( array_key_exists('flash', $_REQUEST) )
- 		$flash = !empty($_REQUEST['flash']);
- 	return $flash;
- }
- 
- add_filter('flash_uploader', 'media_upload_use_flash');
- 
- /**
-  * {@internal Missing Short Description}}
-  *
   * @since 2.6.0
   */
  function media_upload_flash_bypass() {
! 	echo '<p class="upload-flash-bypass">';
! 	printf( __('You are using the Flash uploader.  Problems?  Try the <a href="%s">Browser uploader</a> instead.'), esc_url(add_query_arg('flash', 0)) );
! 	echo '</p>';
  }
  
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.6.0
   */
! function media_upload_html_bypass($flash = true) {
! 	echo '<p class="upload-html-bypass hide-if-no-js">';
! 	_e('You are using the Browser uploader.');
! 	if ( $flash ) {
! 		// the user manually selected the browser uploader, so let them switch back to Flash
! 		echo ' ';
! 		printf( __('Try the <a href="%s">Flash uploader</a> instead.'), esc_url(add_query_arg('flash', 1)) );
! 	}
! 	echo "</p>\n";
  }
- 
- add_action('post-flash-upload-ui', 'media_upload_flash_bypass');
  add_action('post-html-upload-ui', 'media_upload_html_bypass');
  
  /**
   * {@internal Missing Short Description}}
   *
-  * Make sure the GET parameter sticks when we submit a form.
-  *
   * @since 2.6.0
-  *
-  * @param unknown_type $url
-  * @return unknown
   */
! function media_upload_bypass_url($url) {
! 	if ( array_key_exists('flash', $_REQUEST) )
! 		$url = add_query_arg('flash', intval($_REQUEST['flash']));
! 	return $url;
  }
  
! add_filter('media_upload_form_url', 'media_upload_bypass_url');
! 
! add_filter('async_upload_image', 'get_media_item', 10, 2);
! add_filter('async_upload_audio', 'get_media_item', 10, 2);
! add_filter('async_upload_video', 'get_media_item', 10, 2);
! add_filter('async_upload_file', 'get_media_item', 10, 2);
! 
! add_action('media_upload_image', 'media_upload_image');
! add_action('media_upload_audio', 'media_upload_audio');
! add_action('media_upload_video', 'media_upload_video');
! add_action('media_upload_file', 'media_upload_file');
! 
! add_filter('media_upload_gallery', 'media_upload_gallery');
  
! add_filter('media_upload_library', 'media_upload_library');
--- 2035,2105 ----
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.6.0
   */
  function media_upload_flash_bypass() {
! 	?>
! 	<p class="upload-flash-bypass">
! 	<?php _e('You are using the multi-file uploader. Problems? Try the <a href="#">browser uploader</a> instead.'); ?>
! 	</p>
! 	<?php
  }
+ add_action('post-plupload-upload-ui', 'media_upload_flash_bypass');
  
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.6.0
   */
! function media_upload_html_bypass() {
! 	?>
! 	<p class="upload-html-bypass hide-if-no-js">
! 	<?php _e('You are using the browser&#8217;s built-in file uploader. The new WordPress uploader includes multiple file selection and drag and drop capability. <a href="#">Switch to the new uploader</a>.'); ?>
! 	</p>
! 	<?php
  }
  add_action('post-html-upload-ui', 'media_upload_html_bypass');
  
+ function media_upload_text_after() {
+ 	?>
+ 	<span class="after-file-upload"><?php _e('After a file has been uploaded, you can add titles and descriptions.'); ?></span>
+ 	<?php
+ }
+ add_action('post-upload-ui', 'media_upload_text_after', 5);
+ 
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.6.0
   */
! function media_upload_max_image_resize() {
! 	$checked = get_user_setting('upload_resize') ? ' checked="true"' : '';
! 	$a = $end = '';
! 
! 	if ( current_user_can( 'manage_options' ) ) {
! 		$a = '<a href="' . esc_url( admin_url( 'options-media.php' ) ) . '" target="_blank">';
! 		$end = '</a>';
! 	}
! ?>
! <p class="hide-if-no-js"><label>
! <input name="image_resize" type="checkbox" id="image_resize" value="true"<?php echo $checked; ?> />
! <?php
! 	/* translators: %1$s is link start tag, %2$s is link end tag, %3$d is width, %4$d is height*/
! 	printf( __( 'Scale images to match the large size selected in %1$simage options%2$s (%3$d &times; %4$d).' ), $a, $end, (int) get_option( 'large_size_w', '1024' ), (int) get_option( 'large_size_h', '1024' ) );
! ?>
! </label></p>
! <?php
  }
  
! add_filter( 'async_upload_image', 'get_media_item', 10, 2 );
! add_filter( 'async_upload_audio', 'get_media_item', 10, 2 );
! add_filter( 'async_upload_video', 'get_media_item', 10, 2 );
! add_filter( 'async_upload_file',  'get_media_item', 10, 2 );
! 
! add_action( 'media_upload_image', 'wp_media_upload_handler' );
! add_action( 'media_upload_audio', 'wp_media_upload_handler' );
! add_action( 'media_upload_video', 'wp_media_upload_handler' );
! add_action( 'media_upload_file',  'wp_media_upload_handler' );
  
! add_filter( 'media_upload_gallery', 'media_upload_gallery' );
! add_filter( 'media_upload_library', 'media_upload_library' );
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/menu.php ./wordpress-3.3/wp-admin/includes/menu.php
*** ./wordpress-3.2.1/wp-admin/includes/menu.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/menu.php	2011-10-27 15:00:09.000000000 -0500
***************
*** 215,222 ****
  }
  
  // Remove the last menu item if it is a separator.
! $last_menu_key = array_pop( array_keys( $menu ) );
! if ( 'wp-menu-separator' == $menu[ $last_menu_key ][ 4 ] )
  	unset( $menu[ $last_menu_key ] );
  unset( $last_menu_key );
  
--- 215,223 ----
  }
  
  // Remove the last menu item if it is a separator.
! $last_menu_key = array_keys( $menu );
! $last_menu_key = array_pop( $last_menu_key );
! if ( !empty( $menu ) && 'wp-menu-separator' == $menu[ $last_menu_key ][ 4 ] )
  	unset( $menu[ $last_menu_key ] );
  unset( $last_menu_key );
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/meta-boxes.php ./wordpress-3.3/wp-admin/includes/meta-boxes.php
*** ./wordpress-3.2.1/wp-admin/includes/meta-boxes.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/meta-boxes.php	2011-09-29 16:21:15.000000000 -0500
***************
*** 155,161 ****
  </div><?php // /misc-pub-section ?>
  
  <?php
! // translators: Publish box date formt, see http://php.net/date
  $datef = __( 'M j, Y @ G:i' );
  if ( 0 != $post->ID ) {
  	if ( 'future' == $post->post_status ) { // scheduled for publishing at a future date
--- 155,161 ----
  </div><?php // /misc-pub-section ?>
  
  <?php
! // translators: Publish box date format, see http://php.net/date
  $datef = __( 'M j, Y @ G:i' );
  if ( 0 != $post->ID ) {
  	if ( 'future' == $post->post_status ) { // scheduled for publishing at a future date
***************
*** 425,431 ****
  <div id="ajax-response"></div>
  <?php
  $metadata = has_meta($post->ID);
! list_meta($metadata);
  meta_form(); ?>
  </div>
  <p><?php _e('Custom fields can be used to add extra metadata to a post that you can <a href="http://codex.wordpress.org/Using_Custom_Fields" target="_blank">use in your theme</a>.'); ?></p>
--- 425,435 ----
  <div id="ajax-response"></div>
  <?php
  $metadata = has_meta($post->ID);
! foreach ( $metadata as $key => $value ) {
! 	if ( is_protected_meta( $metadata[ $key ][ 'meta_key' ], 'post' ) || ! current_user_can( 'edit_post_meta', $post->ID, $metadata[ $key ][ 'meta_key' ] ) )
! 		unset( $metadata[ $key ] );
! }
! list_meta( $metadata );
  meta_form(); ?>
  </div>
  <p><?php _e('Custom fields can be used to add extra metadata to a post that you can <a href="http://codex.wordpress.org/Using_Custom_Fields" target="_blank">use in your theme</a>.'); ?></p>
***************
*** 556,562 ****
  function page_attributes_meta_box($post) {
  	$post_type_object = get_post_type_object($post->post_type);
  	if ( $post_type_object->hierarchical ) {
! 		$pages = wp_dropdown_pages(array('post_type' => $post->post_type, 'exclude_tree' => $post->ID, 'selected' => $post->post_parent, 'name' => 'parent_id', 'show_option_none' => __('(no parent)'), 'sort_column'=> 'menu_order, post_title', 'echo' => 0));
  		if ( ! empty($pages) ) {
  ?>
  <p><strong><?php _e('Parent') ?></strong></p>
--- 560,577 ----
  function page_attributes_meta_box($post) {
  	$post_type_object = get_post_type_object($post->post_type);
  	if ( $post_type_object->hierarchical ) {
! 		$dropdown_args = array(
! 			'post_type'        => $post->post_type,
! 			'exclude_tree'     => $post->ID,
! 			'selected'         => $post->post_parent,
! 			'name'             => 'parent_id',
! 			'show_option_none' => __('(no parent)'),
! 			'sort_column'      => 'menu_order, post_title',
! 			'echo'             => 0,
! 		);
! 
! 		$dropdown_args = apply_filters( 'page_attributes_dropdown_pages_args', $dropdown_args, $post );
! 		$pages = wp_dropdown_pages( $dropdown_args );
  		if ( ! empty($pages) ) {
  ?>
  <p><strong><?php _e('Parent') ?></strong></p>
